From 455ab9a811e66ad6ae2cb46a3fa616584da39a29 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:08 +0000
Subject: [PATCH 954/1001] Use a REST API for hub and widget config


---

diff --git a/hubs/tests/utils/test_views.py b/hubs/tests/utils/test_views.py
index 262df3d..9c4f54f 100644
--- a/hubs/tests/utils/test_views.py
+++ b/hubs/tests/utils/test_views.py
@@ -5,7 +5,7 @@ import flask
 import hubs.models
 from hubs.app import app
 from hubs.tests import APPTest, FakeAuthorization, auth_set, app_config
-from hubs.utils.views import get_visible_widgets, get_sse_url
+from hubs.utils.views import get_visible_widgets, get_sse_url, move_widget
 
 
 class ViewUtilsTest(APPTest):
@@ -129,3 +129,50 @@ class ViewUtilsTest(APPTest):
                 self.assertEqual(
                     get_sse_url("hub/ralph"),
                     "http://example.com/hub/ralph")
+
+    def test_move_widget(self):
+        hub = hubs.models.Hub(name="testing")
+        self.session.add(hub)
+        widget_names = ["about", "badges", "bugzilla", "contact", "dummy"]
+
+        def get_names():
+            return [
+                w.plugin for w in
+                hubs.models.Widget.query.filter_by(hub=hub).order_by(hubs.models.Widget.index)
+                ]
+
+        def get_widget(name):
+            return hubs.models.Widget.query.filter_by(hub=hub, plugin=name).one()
+
+        def check_move(name, position, expected):
+            move_widget(get_widget(name), position)
+            self.session.flush()
+            self.session.refresh(hub)
+            self.assertListEqual(get_names(), expected)
+
+        for index, name in enumerate(widget_names):
+            widget = hubs.models.Widget(
+                hub=hub, plugin=name,
+                left=True, index=index, _config="{}")
+            self.session.add(widget)
+        self.assertListEqual(get_names(), widget_names)
+        # From middle to middle forwards
+        check_move(
+            "badges", 3,
+            ["about", "bugzilla", "contact", "badges", "dummy"])
+        # From middle to middle backwards
+        check_move(
+            "badges", 1,
+            ["about", "badges", "bugzilla", "contact", "dummy"])
+        # From middle to start
+        check_move(
+            "contact", 0,
+            ["contact", "about", "badges", "bugzilla", "dummy"])
+        # From middle to end
+        check_move(
+            "badges", 5,
+            ["contact", "about", "bugzilla", "dummy", "badges"])
+        # From start to end
+        check_move(
+            "contact", 5,
+            ["about", "bugzilla", "dummy", "badges", "contact"])
